////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Copyright (c) Microsoft Corporation.  All rights reserved.
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
// Portions Copyright (c) 2010-2011 Kentaro Sekimoto  All rights reserved.
////////////////////////////////////////////////////////////////////////////

#include <tinyhal.h>

//--//

extern struct CompressedImage_Header TinyBooterCompressed_Dat;

typedef unsigned char UINT8;

int LZ77_Decompress( UINT8* inBuf, int inSize, UINT8* outBuf, int outSize );

HAL_DECLARE_NULL_HEAP();

typedef void (*APP_ENTRY_POINT)();

static unsigned int SwapEndian(unsigned int u)
{
    return (u>>24) | ((u &0xff0000UL)>>8) | ((u&0xff00UL)<<8) | ((u)<<24);
}

extern "C"
{
void BootEntryLoader()
{
    struct CompressedImage_Header* hdr  = (struct CompressedImage_Header*)&TinyBooterCompressed_Dat;
    hdr->Destination = (char *)SwapEndian((unsigned int)(hdr->Destination));
    hdr->Compressed = (int)SwapEndian((unsigned int)(hdr->Compressed));
    hdr->Uncompressed = (int)SwapEndian((unsigned int)(hdr->Uncompressed));
    void*                          data = &hdr[ 1 ];
    APP_ENTRY_POINT            AppEntry = (APP_ENTRY_POINT)hdr->Destination;

    LZ77_Decompress( (UINT8*)data, hdr->Compressed, (UINT8*)hdr->Destination, hdr->Uncompressed );

    CPU_FlushCaches();

    AppEntry();
}
}

void ApplicationEntryPoint()
{
}


