////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2012 Kentaro Sekimoto  All rights reserved.
////////////////////////////////////////////////////////////////////////////

#include <tinyhal.h>

//--//
#ifndef _FM3_FRAM_H_
#define _FM3_FRAM_H_ 1

struct FM3_FRAM_Driver
{
	typedef UINT16 CHIP_WORD;

	static BOOL ChipInitialize(void *context) __attribute__((section("SectionForFlashOperations")));
	static BOOL ChipUnInitialize(void *context) __attribute__((section("SectionForFlashOperations")));
	static const BlockDeviceInfo* GetDeviceInfo(void *context) __attribute__((section("SectionForFlashOperations")));
	static BOOL Read(void *context, ByteAddress Address, UINT32 NumBytes, BYTE *pSectorBuff) __attribute__((section("SectionForFlashOperations")));
	static BOOL Write(void *context, ByteAddress Address, UINT32 NumBytes, BYTE *pSectorBuff, BOOL ReadModifyWrite) __attribute__((section("SectionForFlashOperations")));
	static BOOL Memset(void *context, ByteAddress Address, UINT8 Data, UINT32 NumBytes) __attribute__((section("SectionForFlashOperations")));
	static BOOL GetSectorMetadata(void* context, ByteAddress SectorStart, SectorMetadata *pSectorMetadata) __attribute__((section("SectionForFlashOperations")));
	static BOOL SetSectorMetadata(void* context, ByteAddress SectorStart, SectorMetadata *pSectorMetadata) __attribute__((section("SectionForFlashOperations")));
	static BOOL IsBlockErased(void *context, ByteAddress BlockStart, UINT32 BlockLength) __attribute__((section("SectionForFlashOperations")));
	static BOOL EraseBlock(void *context, ByteAddress Address) __attribute__((section("SectionForFlashOperations")));
	static void SetPowerState(void *context, UINT32 State) __attribute__((section("SectionForFlashOperations")));
	static UINT32 MaxSectorWrite_uSec(void *context) __attribute__((section("SectionForFlashOperations")));
	static UINT32 MaxBlockErase_uSec(void *context) __attribute__((section("SectionForFlashOperations")));
};

#endif // _FM3_FRAM_H_

