////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2012 Kentaro Sekimoto  All rights reserved.
////////////////////////////////////////////////////////////////////////////

#include <tinyhal.h>
#include "..\FM3.h"

//--//

const UINT8 FM3_GPIO_Driver::c_GPIO_Attributes[FM3_GPIO_Driver::c_MaxPins] =
{
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P00
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P01
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P02
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P03
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P04
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P05
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P06
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P07
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P08
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P09
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P0A
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P0B
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P0C
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P0D
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P0E
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P0F

        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P10
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P11
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P12
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P13
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P14
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P15
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P16
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P17
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P18
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P19
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P1A
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P1B
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P1C
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P1D
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P1E
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P1F

        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P20
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P21
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P22
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P23
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P24
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P25
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P26
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P27
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P28
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P29
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P2A
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P2B
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P2C
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P2D
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P2E
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P2F

        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P30
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P31
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P32
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P33
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P34
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P35
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P36
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P37
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P38
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P39
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P3A
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P3B
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P3C
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P3D
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P3E
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P3F

        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P40
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P41
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P42
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P43
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P44
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P45
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P46
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P47
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P48
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P49
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P4A
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P4B
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P4C
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P4D
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P4E
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P4F

        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P50
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P51
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P52
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P53
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P54
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P55
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P56
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P57
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P58
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P59
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P5A
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P5B
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P5C
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P5D
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P5E
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P5F

        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P60
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P61
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P62
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P63
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P64
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P65
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P66
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P67
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P68
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P69
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P6A
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P6B
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P6C
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P6D
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P6E
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P6F

        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P70
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P71
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P72
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P73
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P74
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P75
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P76
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P77
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P78
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P79
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P7A
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P7B
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P7C
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P7D
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P7E
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P7F

        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P80
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P81
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P82
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P83
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P84
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P85
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P86
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P87
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P88
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P89
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P8A
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P8B
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P8C
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P8D
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P8E
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P8F

        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P90
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P91
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P92
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P93
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P94
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P95
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P96
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P97
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P98
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P99
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P9A
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P9B
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P9C
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P9D
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P9E
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // P9F

        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PA0
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PA1
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PA2
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PA3
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PA4
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PA5
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PA6
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PA7
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PA8
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PA9
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PAA
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PAB
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PAC
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PAD
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PAE
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PAF

        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PB0
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PB1
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PB2
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PB3
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PB4
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PB5
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PB6
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PB7
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PB8
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PB9
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PBA
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PBB
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PBC
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PBD
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PBE
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PBF

        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PC0
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PC1
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PC2
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PC3
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PC4
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PC5
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PC6
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PC7
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PC8
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PC9
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PCA
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PCB
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PCC
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PCD
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PCE
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PCF

        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PD0
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PD1
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PD2
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PD3
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PD4
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PD5
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PD6
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PD7
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PD8
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PD9
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PDA
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PDB
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PDC
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PDD
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PDE
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PDF

        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PE0
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PE1
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PE2
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PE3
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PE4
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PE5
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PE6
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PE7
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PE8
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PE9
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PEA
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PEB
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PEC
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PED
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PEE
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PEF

        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PF0
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PF1
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PF2
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PF3
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PF4
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PF5
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PF6
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PF7
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PF8
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PF9
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PFA
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PFB
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PFC
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PFD
        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT,    // PFE
//        GPIO_ATTRIBUTE_INPUT | GPIO_ATTRIBUTE_OUTPUT    // PFF
};

FM3_GPIO_Driver g_FM3_GPIO_Driver;

BOOL CPU_GPIO_Initialize()
{
    return FM3_GPIO_Driver::Initialize();
}

BOOL CPU_GPIO_Uninitialize()
{
    return FM3_GPIO_Driver::Uninitialize();
}

UINT32 CPU_GPIO_Attributes(GPIO_PIN Pin)
{
    return FM3_GPIO_Driver::Attributes(Pin);
}

void CPU_GPIO_DisablePin(GPIO_PIN Pin, GPIO_RESISTOR ResistorState, UINT32 Direction, GPIO_ALT_MODE AltFunction)
{
    FM3_GPIO_Driver::DisablePin(Pin, ResistorState, Direction, AltFunction);
}

void CPU_GPIO_EnableOutputPin(GPIO_PIN Pin, BOOL InitialState)
{
    FM3_GPIO_Driver::EnableOutputPin(Pin, InitialState);
}

BOOL CPU_GPIO_EnableInputPin(GPIO_PIN Pin, BOOL GlitchFilterEnable, GPIO_INTERRUPT_SERVICE_ROUTINE ISR, GPIO_INT_EDGE IntEdge, GPIO_RESISTOR ResistorState)
{
    return FM3_GPIO_Driver::EnableInputPin(Pin, GlitchFilterEnable, ISR, 0, IntEdge, ResistorState);
}

BOOL CPU_GPIO_EnableInputPin2(GPIO_PIN Pin, BOOL GlitchFilterEnable, GPIO_INTERRUPT_SERVICE_ROUTINE ISR, void* ISR_Param, GPIO_INT_EDGE IntEdge, GPIO_RESISTOR ResistorState)
{
    return FM3_GPIO_Driver::EnableInputPin(Pin, GlitchFilterEnable, ISR, ISR_Param, IntEdge, ResistorState);
}

BOOL CPU_GPIO_GetPinState(GPIO_PIN Pin)
{
    return FM3_GPIO_Driver::GetPinState(Pin);
}

void CPU_GPIO_SetPinState(GPIO_PIN Pin, BOOL PinState)
{
    FM3_GPIO_Driver::SetPinState(Pin, PinState);
}

INT32 CPU_GPIO_GetPinCount()
{
    return FM3_GPIO_Driver::GetPinCount();
}

void CPU_GPIO_GetPinsMap(UINT8* pins, size_t size)
{
    FM3_GPIO_Driver::GetPinsMap( pins, size );
}

UINT8 CPU_GPIO_GetSupportedResistorModes(GPIO_PIN pin)
{
    return FM3_GPIO_Driver::GetSupportedResistorModes(pin);
}

UINT8 CPU_GPIO_GetSupportedInterruptModes(GPIO_PIN pin)
{
    return FM3_GPIO_Driver::GetSupportedInterruptModes(pin);
}

BOOL CPU_GPIO_PinIsBusy(GPIO_PIN Pin)
{
    return FM3_GPIO_Driver::PinIsBusy(Pin);
}

BOOL CPU_GPIO_ReservePin(GPIO_PIN Pin, BOOL fReserve)
{
    return FM3_GPIO_Driver::ReservePin(Pin, fReserve);
}

UINT32 CPU_GPIO_GetDebounce()
{
    return FM3_GPIO_Driver::GetDebounce();
}

BOOL CPU_GPIO_SetDebounce(INT64 debounceTimeMilliseconds )
{
    return FM3_GPIO_Driver::SetDebounce(debounceTimeMilliseconds);
}

#ifdef FM3_GPIO_INT
INT32 FM3_GPIO_Driver::GetBitPos(UINT16 val)
{
    INT32 pos = 0;
    while (pos < 16) {
        if (val & 1)
            return pos;
        pos++;
        val >>= 1;
    }
    return -1;
}

void FM3_GPIO_Driver::UpdatePinValue(GPIO_PIN pin)
{
    UINT32 port = GPIO_PORT(pin);
    UINT32 mask = GPIO_MASK(pin);
    g_FM3_GPIO_Driver.m_GPIO_PortLastValues[port] &= ~mask;
    g_FM3_GPIO_Driver.m_GPIO_PortLastValues[port] |= (GPIO_PDIR(port) & mask);
}

void FM3_GPIO_Driver::EnableInputPolling(GPIO_PIN pin)
{
    g_FM3_GPIO_Driver.m_GPIO_PortReservedMask[GPIO_PORT(pin)] |= GPIO_MASK(pin);
}
void FM3_GPIO_Driver::DisableInputPolling(GPIO_PIN pin)
{
    g_FM3_GPIO_Driver.m_GPIO_PortReservedMask[GPIO_PORT(pin)] &= ~GPIO_MASK(pin);
}

void FM3_GPIO_Driver::ISR(void)
{
    UINT32 pin;
    NATIVE_PROFILE_HAL_PROCESSOR_GPIO();
    if (g_FM3_GPIO_Driver.m_GPIO_InISR == false) {
        g_FM3_GPIO_Driver.m_GPIO_InISR = true;
        pin = ChkPinChange();
        if (pin != 255) {
            PIN_ISR_DESCRIPTOR& pinIsr = g_FM3_GPIO_Driver.m_PinIsr[pin];
            if (pinIsr.m_intEdge != GPIO_INT_NONE)
                pinIsr.Fire((void *)&pinIsr);
        }
        g_FM3_GPIO_Driver.m_GPIO_InISR = false;
    }
    g_FM3_GPIO_Driver.m_GPIO_Completion.EnqueueDelta(FM3_GPIO_POLLING_INTERVAL);
    return;
}

UINT32 FM3_GPIO_Driver::ChkPinChange(void)
{
    INT32 i, pos;
    UINT16 val, b, mask;
    UINT32 pin = 255;
    GLOBAL_LOCK(irq);
    for (i = 0; i < c_MaxPorts; i++) {
        mask = g_FM3_GPIO_Driver.m_GPIO_PortReservedMask[i];
        if (mask) {
            val = GPIO_PDIR(i) & mask;
            if (g_FM3_GPIO_Driver.m_GPIO_PortLastValues[i] != val) {
                b = g_FM3_GPIO_Driver.m_GPIO_PortLastValues[i] ^ val;
                g_FM3_GPIO_Driver.m_GPIO_PortLastValues[i] = val;
                pos = GetBitPos(b);
                if (pos != -1) {
                    pin = i*16 + pos;
                    if (pin != 255) {
                        //lcd_printf("%02X ", pin);
                        PIN_ISR_DESCRIPTOR& pinIsr = g_FM3_GPIO_Driver.m_PinIsr[pin];
                        if (b & val) {
                            // low -> high
                            pinIsr.m_status = PIN_ISR_DESCRIPTOR::c_Status_AllowHighEdge;
                        } else {
                            // high -> low
                            pinIsr.m_status = PIN_ISR_DESCRIPTOR::c_Status_AllowLowEdge;
                        }
                    }
                    break;
                }
            }
        }
    }
    return pin;
}

void FM3_GPIO_Driver::PIN_ISR_DESCRIPTOR::Fire(void *arg)
{
    NATIVE_PROFILE_HAL_PROCESSOR_GPIO();
    PIN_ISR_DESCRIPTOR *desc = (PIN_ISR_DESCRIPTOR *)arg;
    desc->m_isr(desc->m_pin, (desc->m_status & c_Status_AllowHighEdge) != 0, desc->m_param);
    UINT8 mask = c_Flags_RequireHighEdge | c_Flags_RequireLowEdge;
    if ((desc->m_flags & mask) == mask) {
        desc->m_status ^= PIN_ISR_DESCRIPTOR::c_Status_AllowLowEdge | PIN_ISR_DESCRIPTOR::c_Status_AllowHighEdge;
    }
}
#endif

void FM3_GPIO_Driver::STUB_GPIOISRVector(GPIO_PIN Pin, BOOL PinState, void *Param)
{
}

BOOL FM3_GPIO_Driver::Initialize()
{
    NATIVE_PROFILE_HAL_PROCESSOR_GPIO();
    //FM3_GPIO->ADE = (UINT32)0;
#ifdef FM3_GPIO_INT
    PIN_ISR_DESCRIPTOR *pinIsr = g_FM3_GPIO_Driver.m_PinIsr;
#endif
    for (UINT32 port = 0; port < c_MaxPorts; port++) {
        g_FM3_GPIO_Driver.m_GPIO_PortReservedMask[port] = 0;
        g_FM3_GPIO_Driver.m_GPIO_PortLastValues[port] = 0;
    }

    for (UINT32 pin = 0; pin < c_MaxPins; pin++) {
        g_FM3_GPIO_Driver.m_GPIO_Reserved[pin] = false;
#ifdef FM3_GPIO_INT
        pinIsr->m_pin = pin;
        pinIsr->m_intEdge = GPIO_INT_NONE;
        pinIsr->m_isr = (GPIO_INTERRUPT_SERVICE_ROUTINE)STUB_GPIOISRVector;
        pinIsr->m_param = NULL;
        pinIsr->m_completion.Initialize();
        pinIsr->m_completion.InitializeForISR(&PIN_ISR_DESCRIPTOR::Fire, pinIsr);
        pinIsr++;
#endif
    }
    g_FM3_GPIO_Driver.m_GPIO_Driver_Initialized = true;
    SetDebounce(20);
#ifdef FM3_GPIO_INT
    g_FM3_GPIO_Driver.m_GPIO_Completion.Initialize();
    g_FM3_GPIO_Driver.m_GPIO_Completion.InitializeForISR((HAL_CALLBACK_FPN)ISR, NULL);
    g_FM3_GPIO_Driver.m_GPIO_Completion.EnqueueDelta(FM3_GPIO_POLLING_INTERVAL);
#endif
    return true;
}

///////////////////////////////////////////////////////////////////////////////
//  Uninitialize
///////////////////////////////////////////////////////////////////////////////

BOOL FM3_GPIO_Driver::Uninitialize()
{
    NATIVE_PROFILE_HAL_PROCESSOR_GPIO();
    GLOBAL_LOCK(irq);
    g_FM3_GPIO_Driver.m_GPIO_Driver_Initialized = false;
#ifdef FM3_GPIO_INT
    PIN_ISR_DESCRIPTOR* pinIsr = g_FM3_GPIO_Driver.m_PinIsr;
    for (UINT32 pin = 0; pin < c_MaxPins; pin++) {
        pinIsr->m_completion.Abort();
        pinIsr++;
    }
    g_FM3_GPIO_Driver.m_GPIO_Completion.Abort();
#endif
    return true;
}

///////////////////////////////////////////////////////////////////////////////
//  Attributes
///////////////////////////////////////////////////////////////////////////////

UINT32 FM3_GPIO_Driver::Attributes(GPIO_PIN pin)
{
    NATIVE_PROFILE_HAL_PROCESSOR_GPIO();
    if ((UINT32)pin < c_MaxPins) {
        return c_GPIO_Attributes[pin];
    }
    return GPIO_ATTRIBUTE_NONE;
}

///////////////////////////////////////////////////////////////////////////////
//  DisablePin
///////////////////////////////////////////////////////////////////////////////

void FM3_GPIO_Driver::DisablePin(GPIO_PIN pin, GPIO_RESISTOR resistorState, UINT32 Direction, GPIO_ALT_MODE AltFunction)
{
    NATIVE_PROFILE_HAL_PROCESSOR_GPIO();
    GLOBAL_LOCK(irq);
    GPIO_PFR(GPIO_PORT(pin)) |= GPIO_MASK(pin);    // Peripheral mode
#ifdef FM3_GPIO_INT
    PIN_ISR_DESCRIPTOR& pinIsr = g_FM3_GPIO_Driver.m_PinIsr[pin];
    pinIsr.m_intEdge = GPIO_INT_NONE;
    pinIsr.m_isr = (GPIO_INTERRUPT_SERVICE_ROUTINE)STUB_GPIOISRVector;
    pinIsr.m_param = NULL;
    DisableInputPolling(pin);
#endif
}

///////////////////////////////////////////////////////////////////////////////
//  EnableOutputPin
///////////////////////////////////////////////////////////////////////////////

void FM3_GPIO_Driver::EnableOutputPin(GPIO_PIN pin, BOOL initialState)
{
    GLOBAL_LOCK(irq);

    UINT32 port = GPIO_PORT(pin);
    UINT32 mask = GPIO_MASK(pin);

    GPIO_PFR(port) &= ~mask;    // GPIO mode
    GPIO_DDR(port) |= mask;        // output
    if (initialState)
        GPIO_PDOR(port) |= mask;
    else
        GPIO_PDOR(port) &= ~mask;
#ifdef FM3_GPIO_INT
    PIN_ISR_DESCRIPTOR& pinIsr = g_FM3_GPIO_Driver.m_PinIsr[pin];
    pinIsr.m_intEdge = GPIO_INT_NONE;
    pinIsr.m_isr = (GPIO_INTERRUPT_SERVICE_ROUTINE)STUB_GPIOISRVector;
    pinIsr.m_param = NULL;
    DisableInputPolling(pin);
#endif
}

///////////////////////////////////////////////////////////////////////////////
//  EnableInputPin
///////////////////////////////////////////////////////////////////////////////
BOOL FM3_GPIO_Driver::EnableInputPin(GPIO_PIN pin, BOOL GlitchFilterEnable, GPIO_INTERRUPT_SERVICE_ROUTINE ISR, void* Param, GPIO_INT_EDGE intEdge, GPIO_RESISTOR resistorState)
{
    NATIVE_PROFILE_HAL_PROCESSOR_GPIO();
    UINT32 port = GPIO_PORT(pin);
    UINT32 mask = GPIO_MASK(pin);
    BOOL flag = true;
    GLOBAL_LOCK(irq);
#ifdef FM3_GPIO_INT
    PIN_ISR_DESCRIPTOR& pinIsr = g_FM3_GPIO_Driver.m_PinIsr[pin];
    pinIsr.m_intEdge = intEdge;
    pinIsr.m_isr = (ISR != NULL) ? ISR : (GPIO_INTERRUPT_SERVICE_ROUTINE)STUB_GPIOISRVector;
    pinIsr.m_param = Param;
    pinIsr.m_flags = GlitchFilterEnable ? PIN_ISR_DESCRIPTOR::c_Flags_Debounce : 0;
    pinIsr.m_status = 0;
    pinIsr.m_completion.Abort();
    pinIsr.m_completion.Initialize();
#endif
    GPIO_PFR(port) &= ~mask;    // GPIO mode
    GPIO_DDR(port) &= ~mask;    // input
    if (resistorState == RESISTOR_DISABLED) {
        GPIO_PCR(port) &= ~mask;
    } else if (resistorState == RESISTOR_PULLUP) {
        GPIO_PCR(port) |= mask;
    }
#ifdef FM3_GPIO_INT
    if (ISR) {
        switch (intEdge)
        {
        case GPIO_INT_NONE:
            flag = false;
            break;
        case GPIO_INT_EDGE_LOW:
        case GPIO_INT_LEVEL_LOW:
            pinIsr.m_status |= PIN_ISR_DESCRIPTOR::c_Status_AllowLowEdge;
            break;
        case GPIO_INT_EDGE_HIGH:
        case GPIO_INT_LEVEL_HIGH:
            pinIsr.m_status |= PIN_ISR_DESCRIPTOR::c_Status_AllowHighEdge;
            break;
        case GPIO_INT_EDGE_BOTH:
            pinIsr.m_flags |= PIN_ISR_DESCRIPTOR::c_Flags_RequireHighEdge | PIN_ISR_DESCRIPTOR::c_Flags_RequireLowEdge;
            if (GetPinState(pin)) {
                pinIsr.m_status &= ~PIN_ISR_DESCRIPTOR::c_Status_AllowHighEdge;
                pinIsr.m_status |=  PIN_ISR_DESCRIPTOR::c_Status_AllowLowEdge;
            } else {
                pinIsr.m_status &= ~PIN_ISR_DESCRIPTOR::c_Status_AllowLowEdge;
                pinIsr.m_status |=  PIN_ISR_DESCRIPTOR::c_Status_AllowHighEdge;
            }
            break;
        default:
            flag = false;
        }
    }
    UpdatePinValue(pin);
    EnableInputPolling(pin);
#endif
    return flag;
}

///////////////////////////////////////////////////////////////////////////////
//  GetPinState
///////////////////////////////////////////////////////////////////////////////
BOOL FM3_GPIO_Driver::GetPinState(GPIO_PIN pin)
{
    NATIVE_PROFILE_HAL_PROCESSOR_GPIO();
    UINT32 port = GPIO_PORT(pin);
    UINT32 mask = GPIO_MASK(pin);
    GLOBAL_LOCK(irq);
    GPIO_PFR(port) &= ~mask;    // GPIO mode
    GPIO_DDR(port) &= ~mask;    // input
    return GPIO_PDIR(port) & mask;
}

///////////////////////////////////////////////////////////////////////////////
//  SetPinState
///////////////////////////////////////////////////////////////////////////////
void FM3_GPIO_Driver::SetPinState(GPIO_PIN pin, BOOL pinState)
{
    NATIVE_PROFILE_HAL_PROCESSOR_GPIO();
    UINT32 port = GPIO_PORT(pin);
    UINT32 mask = GPIO_MASK(pin);
    GLOBAL_LOCK(irq);
    GPIO_PFR(port) &= ~mask;    // GPIO mode
    GPIO_DDR(port) |= mask;        // output
    if (pinState)
        GPIO_PDOR(port) |= mask;
    else
        GPIO_PDOR(port) &= ~mask;
}

///////////////////////////////////////////////////////////////////////////////
//  PinIsBusy
///////////////////////////////////////////////////////////////////////////////
BOOL FM3_GPIO_Driver::PinIsBusy(GPIO_PIN pin)
{
    NATIVE_PROFILE_HAL_PROCESSOR_GPIO();
    return g_FM3_GPIO_Driver.m_GPIO_Reserved[pin];
}

///////////////////////////////////////////////////////////////////////////////
//  ReservePin
///////////////////////////////////////////////////////////////////////////////
BOOL FM3_GPIO_Driver::ReservePin(GPIO_PIN pin, BOOL fReserve)
{
    NATIVE_PROFILE_HAL_PROCESSOR_GPIO();
    GLOBAL_LOCK(irq);
    g_FM3_GPIO_Driver.m_GPIO_Reserved[pin] = fReserve;
    return true;
}

///////////////////////////////////////////////////////////////////////////////
//  GetDebounce
///////////////////////////////////////////////////////////////////////////////
UINT32 FM3_GPIO_Driver::GetDebounce()
{
    NATIVE_PROFILE_HAL_PROCESSOR_GPIO();
    return CPU_TicksToTime(g_FM3_GPIO_Driver.m_DebounceTicks) / 10000;
}

///////////////////////////////////////////////////////////////////////////////
//  SetDebounce
///////////////////////////////////////////////////////////////////////////////
BOOL FM3_GPIO_Driver::SetDebounce(INT64 debounceTimeMilliseconds)
{
    NATIVE_PROFILE_HAL_PROCESSOR_GPIO();
    if (debounceTimeMilliseconds < c_MinDebounceTimeMs || c_MaxDebounceTimeMs < debounceTimeMilliseconds)
        return false;
    g_FM3_GPIO_Driver.m_DebounceTicks = CPU_MillisecondsToTicks((UINT32)debounceTimeMilliseconds);
    return true;
}

INT32 FM3_GPIO_Driver::GetPinCount()
{
    return c_MaxPins;
}

void FM3_GPIO_Driver::GetPinsMap(UINT8* pins, size_t size)
{
    const UINT8 *src = c_GPIO_Attributes;
    UINT8 *dst = pins;
    UINT32 maxpin = c_MaxPins;

    if (size == 0)
        return;
    while ((size--) && (maxpin --)) {
        *dst = *src;
        ++dst; ++src;
    }
}

UINT8 FM3_GPIO_Driver::GetSupportedResistorModes(GPIO_PIN pin)
{
    NATIVE_PROFILE_HAL_PROCESSOR_GPIO();
//    return (1 << RESISTOR_DISABLED) | (1 << RESISTOR_PULLUP) | (1 << RESISTOR_PULLDOWN);
    return (1 << RESISTOR_DISABLED) | (1 << RESISTOR_PULLUP);
}


UINT8 FM3_GPIO_Driver::GetSupportedInterruptModes(GPIO_PIN pin)
{
    NATIVE_PROFILE_HAL_PROCESSOR_GPIO();
    return (1 << GPIO_INT_EDGE_LOW) | (1 << GPIO_INT_EDGE_HIGH ) | (1 << GPIO_INT_EDGE_BOTH);
}
