////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Copyright (c) Microsoft Corporation.  All rights reserved.
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
// Portions Copyright (c) 2012 Kentaro Sekimoto  All rights reserved.
////////////////////////////////////////////////////////////////////////////

#include <tinyhal.h>
#include "..\FM3.h"
#include "FM3_I2C_driver.h"

#define DEF_I2C_CH	5

BOOL I2C_Internal_Initialize()
{
    return FM3_I2C_Driver::Initialize(DEF_I2C_CH);
}

BOOL I2C_Internal_Uninitialize()
{
    return FM3_I2C_Driver::Uninitialize(DEF_I2C_CH);
}

void I2C_Internal_XActionStart(I2C_HAL_XACTION* xAction, bool repeatedStart)
{
    FM3_I2C_Driver::MasterXAction_Start(DEF_I2C_CH, xAction, repeatedStart);
}

void I2C_Internal_XActionStop()
{
    FM3_I2C_Driver::MasterXAction_Stop(DEF_I2C_CH);
}

void I2C_Internal_GetClockRate(UINT32 rateKhz, UINT8& clockRate, UINT8& clockRate2)
{
    FM3_I2C_Driver::GetClockRate(DEF_I2C_CH, rateKhz, clockRate, clockRate2);
}

void I2C_Internal_GetPins(GPIO_PIN& scl, GPIO_PIN& sda)
{
    FM3_I2C_Driver::GetPins(DEF_I2C_CH, scl, sda);
}
