////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2012 Kentaro Sekimoto  All rights reserved.
////////////////////////////////////////////////////////////////////////////

/*
 * debug_sci.cpp
 *
 *  Created on: 2012/01/08
 *      Author: Kentaro Sekimoto
 */
#include <tinyhal.h>
#include "..\FM3.h"
#include "debug_printf.h"

#ifdef USB_DEBUG

#ifndef BIT_SET
#define BIT_SET 1
#endif
#ifndef BIT_CLR
#define BIT_CLR 0
#endif
#ifndef REG_R
#define REG_R(reg)          (reg)
#endif
#ifndef REG_W
#define REG_W(reg, value)   ((reg) = (value))
#endif

void SCI4_Init(void)
{
#ifdef MB9BF618T
    FM3_GPIO->ADE = 0;
    bFM3_GPIO_PFR0_P6 = 1;
#else
    bFM3_GPIO_PFR0_PB = 1;
#endif
    bFM3_GPIO_EPFR08_SOT4B0 = 1;
    bFM3_GPIO_EPFR08_SOT4B1 = 1;
    /* UART4 */
    bFM3_MFS4_UART_SCR_RXE  = 0;
    bFM3_MFS4_UART_SCR_TXE  = 0;
#ifdef MB9BF618T
    FM3_MFS4_UART->BGR0     = 0x39;
    FM3_MFS4_UART->BGR1     = 0x01;
#else
    FM3_MFS4_UART->BGR0     = 0x5B;
    FM3_MFS4_UART->BGR1     = 0x01;
#endif
    bFM3_MFS4_UART_SCR_UPCL = 0;

    FM3_MFS4_UART->SMR      = 0x01;
    FM3_MFS4_UART->SSR      = 0x00;
    FM3_MFS4_UART->ESCR     = 0;
    FM3_MFS4_UART->SCR      = 0x01;
    bFM3_MFS4_UART_SSR_REC  = 0;
    return;
}

void SCI4_TxStr(unsigned char* p)
{
    bFM3_MFS4_UART_SCR_TXE = BIT_SET;
    while (*p != 0) {
        if (*p == '\n') {
            FM3_MFS4_UART->TDR = '\r';
            while (bFM3_MFS4_UART_SSR_TDRE == BIT_CLR) ;
        }
        FM3_MFS4_UART->TDR = *p;
        while (bFM3_MFS4_UART_SSR_TDRE == BIT_CLR) ;
        p++;
    }
    while (bFM3_MFS4_UART_SSR_TDRE == BIT_CLR) ;
    return;
}
#endif
