////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2010-2011 Kentaro Sekimoto  All rights reserved.
////////////////////////////////////////////////////////////////////////////
#include <tinyhal.h>

#include "..\..\..\DeviceCode\pal\lwip\lwip_1_3_2\src\include\lwip\init.h"
#include "..\..\..\DeviceCode\pal\lwip\lwip_1_3_2\src\include\lwip\tcpip.h"
#include "..\..\..\DeviceCode\pal\lwip\lwip_1_3_2\src\include\lwip\opt.h"
#include "..\..\..\DeviceCode\pal\lwip\lwip_1_3_2\src\include\lwip\netif.h"
#include "..\..\..\DeviceCode\pal\lwip\lwip_1_3_2\src\include\lwip\tcp.h"
#include "..\..\..\DeviceCode\pal\lwip\lwip_1_3_2\src\include\lwip\udp.h"
#include "..\..\..\DeviceCode\pal\lwip\lwip_1_3_2\src\include\lwip\sockets.h"
#include "..\..\..\DeviceCode\pal\lwip\lwip_1_3_2\src\include\ipv4\lwip\ip_addr.h"
#include "..\..\..\DeviceCode\pal\lwip\lwip_1_3_2\src\include\netif\etharp.h"
#include "..\..\..\DeviceCode\pal\lwip\lwip_1_3_2\src\include\netif\loopif.h"
#include "..\..\..\DeviceCode\Drivers\Ethernet\loopback_lwip\loopback_lwip_driver.h"
#include "..\..\..\DeviceCode\pal\lwip\SocketsDriver\lwIP_Sockets.h"

HAL_DECLARE_NULL_HEAP();
//HAL_DECLARE_CUSTOM_HEAP(SimpleHeap_Allocate, SimpleHeap_Release,SimpleHeap_ReAllocate);
void PostManagedEvent( UINT8 category, UINT8 subCategory, UINT16 data1, UINT32 data2 )
{
}

void  Network_PostEvent(UINT32 evt, UINT32 data)
{
}

#define BUF_SIZE	1518
char buffer[BUF_SIZE];
char HTTP_HEADER[] =
	"HTTP/1.0 200 OK\r\n"
	"Content-Length: 20\r\n"
	"Content-Type: text/html\r\n\r\n"
	"Hello\r\n";

void TestLWIP(void)
{
    SOCK_SOCKET server;
	SOCK_SOCKET client;
	SOCK_sockaddr serverAddress;
	SOCK_sockaddr clientAddress;
    struct ip_addr AnyIpAddrLB;
    IP4_ADDR(&AnyIpAddrLB, 0,0,0,0);

    hal_printf("========== TestLWIP ==========\r\n");
    hal_printf("Waiting for Link Update\r\n");
//	LWIP_SOCKETS_Driver::Initialize();
    Events_WaitForEvents(0, 3000);
	server = LWIP_SOCKETS_Driver::Socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	if (server == -1)
		hal_printf("Socket NG\r\n");
	else
		hal_printf("Socket OK\r\n");
	((SOCK_sockaddr_in*)&serverAddress)->sin_family = AF_INET;
	((SOCK_sockaddr_in*)&serverAddress)->sin_port = htons(80);
	((SOCK_sockaddr_in*)&serverAddress)->sin_addr.S_un.S_addr = *(u32_t*)&AnyIpAddrLB;
	int len = sizeof(serverAddress);
	if (LWIP_SOCKETS_Driver::Bind(server, &serverAddress, len) == -1)
		hal_printf("Bind NG\r\n");
	else
		hal_printf("Bind OK\r\n");
	if (LWIP_SOCKETS_Driver::Listen(server, 4) == -1)
		hal_printf("Listen NG\r\n");
	else
		hal_printf("Listen OK\r\n");
	((SOCK_sockaddr_in*)&clientAddress)->sin_family = AF_INET;
	((SOCK_sockaddr_in*)&clientAddress)->sin_port = htons(80);
	((SOCK_sockaddr_in*)&clientAddress)->sin_addr.S_un.S_addr = *(u32_t*)&AnyIpAddrLB;
	while (true) {
        do {
        	client = LWIP_SOCKETS_Driver::Accept(server, &clientAddress, &len);
            Events_WaitForEvents(0,100);
        } while (client == -1);
    	int recvd;
        do {
            recvd = LWIP_SOCKETS_Driver::Recv(client, buffer, sizeof(buffer), 0);
            if (recvd == -1) {
                hal_printf("Receive NG errno=%d\r", errno);
                Events_WaitForEvents(0, 5000);
            }
        } while (recvd == -1);
        buffer[recvd] = 0;
        hal_printf("received request %d bytes\r\n", recvd);
        if (LWIP_SOCKETS_Driver::Send(client, HTTP_HEADER, sizeof(HTTP_HEADER), 0) == -1) {
        	lcd_printf("Send NG errno=%d\r\n", errno);
        }
        LWIP_SOCKETS_Driver::Close(client);
    }
    LWIP_SOCKETS_Driver::Close(server);
}

void ApplicationEntryPoint()
{
	HalSystemConfig.stdio = COM1;
	HalSystemConfig.DebugTextPort = COM1;
	DebuggerPort_Initialize(HalSystemConfig.DebugTextPort);
	TestLWIP();
	while (true);
}
