////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2011-2012 Kentaro Sekimoto  All rights reserved.
////////////////////////////////////////////////////////////////////////////

#include <tinyhal.h>
#include "..\..\..\..\..\DeviceCode\Targets\Native\FM3\DeviceCode\FM3.h"

#ifdef MB9BF506N
// CLK  P3F
// DI   P3C
// CS   P3D
#define    SSEL1_BIT    0x0d
#define    SCLK1_BIT    0x0f
#define    MOSI1_BIT    0x0c
#define GPIO_MASK        ((1 << SSEL1_BIT) | (1 << SCLK1_BIT) | (1 << MOSI1_BIT))

#define    CS_LOW    (FM3_GPIO->PDOR3 &= ~(1 << SSEL1_BIT))
#define    CS_HIGH    (FM3_GPIO->PDOR3 |= (1 << SSEL1_BIT))
#define    CK_LOW    (FM3_GPIO->PDOR3 &= ~(1 << SCLK1_BIT))
#define    CK_HIGH    (FM3_GPIO->PDOR3 |= (1 << SCLK1_BIT))
#define    DO_LOW    (FM3_GPIO->PDOR3 &= ~(1 << MOSI1_BIT))
#define    DO_HIGH    (FM3_GPIO->PDOR3 |= (1 << MOSI1_BIT))
#endif

#ifdef MB9BF618T
// CLK  P3F
// DI   P3C
// CS   P3D
#define    SSEL1_BIT    0x0d
#define    SCLK1_BIT    0x0f
#define    MOSI1_BIT    0x0c
// CLK  P31
// DI   P32
// CS   P30
//#define    SSEL1_BIT    0x00
//#define    SCLK1_BIT    0x01
//#define    MOSI1_BIT    0x02
#define GPIO_MASK        ((1 << SSEL1_BIT) | (1 << SCLK1_BIT) | (1 << MOSI1_BIT))

#define    CS_LOW    (FM3_GPIO->PDOR3 &= ~(1 << SSEL1_BIT))
#define    CS_HIGH    (FM3_GPIO->PDOR3 |= (1 << SSEL1_BIT))
#define    CK_LOW    (FM3_GPIO->PDOR3 &= ~(1 << SCLK1_BIT))
#define    CK_HIGH    (FM3_GPIO->PDOR3 |= (1 << SCLK1_BIT))
#define    DO_LOW    (FM3_GPIO->PDOR3 &= ~(1 << MOSI1_BIT))
#define    DO_HIGH    (FM3_GPIO->PDOR3 |= (1 << MOSI1_BIT))
#endif

#define    CLK_OUT    (CLK_LOW;CLK_LOW;CLK_HIGH;CLK_HIGH;)

void SPISW_Initialize(void)
{
#ifdef MB9BF506N
    FM3_GPIO->PFR3 &= ~GPIO_MASK;  // GPIO
    FM3_GPIO->DDR3 |= GPIO_MASK;   // Output
#endif
#ifdef MB9BF618T
    FM3_GPIO->PFR3 &= ~GPIO_MASK;  // GPIO
    FM3_GPIO->DDR3 |= GPIO_MASK;   // Output
#endif
    CS_LOW;
    DO_LOW;
    CK_HIGH;
}

void SPISW_Write(UINT8 dat)
{
    (dat & 0x80) ? DO_HIGH : DO_LOW;
    CK_LOW; CK_LOW; CK_HIGH; CK_HIGH;
    (dat & 0x40) ? DO_HIGH : DO_LOW;
    CK_LOW; CK_LOW; CK_HIGH; CK_HIGH;
    (dat & 0x20) ? DO_HIGH : DO_LOW;
    CK_LOW; CK_LOW; CK_HIGH; CK_HIGH;
    (dat & 0x10) ? DO_HIGH : DO_LOW;
    CK_LOW; CK_LOW; CK_HIGH; CK_HIGH;
    (dat & 0x08) ? DO_HIGH : DO_LOW;
    CK_LOW; CK_LOW; CK_HIGH; CK_HIGH;
    (dat & 0x04) ? DO_HIGH : DO_LOW;
    CK_LOW; CK_LOW; CK_HIGH; CK_HIGH;
    (dat & 0x02) ? DO_HIGH : DO_LOW;
    CK_LOW; CK_LOW; CK_HIGH; CK_HIGH;
    (dat & 0x01) ? DO_HIGH : DO_LOW;
    CK_LOW; CK_LOW; CK_HIGH; CK_HIGH;
}

void SPISW_LCD_cmd(UINT8 dat)
{
    // Enter command mode: SDATA=LOW at rising edge of 1st SCLK
    CS_LOW;
    DO_LOW;
    CK_LOW; CK_LOW; CK_HIGH; CK_HIGH;
    SPISW_Write(dat);
    CS_HIGH;
}
void SPISW_LCD_dat(UINT8 dat)
{
    // Enter data mode: SDATA=HIGH at rising edge of 1st SCLK
    CS_LOW;
    DO_HIGH;
    CK_LOW; CK_LOW; CK_HIGH; CK_HIGH;
    SPISW_Write(dat);
    CS_HIGH;
}
