////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2012 Kentaro Sekimoto  All rights reserved.
////////////////////////////////////////////////////////////////////////////

#include <tinyhal.h>
#include "..\..\..\DeviceCode\Targets\Native\FM3\DeviceCode\FM3.h"

void __section(SectionForBootstrapOperations) FM3_InitSRam()
{
}

#define	PFRC_ETH	0xF1FF
#define	PFRD_ETH	0x000F

#define	B_E_TD0E	18
#define	B_E_TD1E	19
#define	B_E_TE0E	20
#define B_E_TE1E	21
#define	B_E_MC0E	22
#define	B_E_MC1B	23
#define	B_E_MD0B	24
#define	B_E_MD1B	25
#define	B_E_CKE		26
#define	B_E_PSE		27
#define	B_E_SPLC	28

void __section(SectionForBootstrapOperations) BootstrapCode_GPIO()
{
#ifdef ETHERNET
	FM3_GPIO->ADE = (UINT32)0;

	FM3_GPIO->PFR6 &= ~0x0004;
	FM3_GPIO->DDR6 &= ~0x0004;
	FM3_GPIO->PFRC = PFRC_ETH;		// GPIO configuration for CH0 and CH1
	FM3_GPIO->PFRD = PFRD_ETH;		// GPIO configuration for CH0 and CH1
	FM3_GPIO->EPFR14 = (3 << B_E_SPLC) |
//						(1 << B_E_PSE) |
			(1 << B_E_CKE) |
			(1 << B_E_MD1B) |
			(1 << B_E_MD0B) |
			(1 << B_E_MC1B) |
			(1 << B_E_MC0E) |
			(1 << B_E_TE1E) |
			(1 << B_E_TE0E) |
			(1 << B_E_TD1E) |
			(1 << B_E_TD0E);
#endif
}
